import os

from PySide2.QtCore import QFile
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QDialog, QWidget, QHBoxLayout, QLabel, QLineEdit, QListWidgetItem, QTextEdit, QVBoxLayout


class WidgetParam(QWidget):
    def __init__(self,name,value,parent=None):
        QWidget.__init__(self,parent)
        layout = QHBoxLayout()
        self.setLayout(layout)
        name_params=QLabel()
        name_params.setText(name)
        layout.addWidget(name_params)
        params_value=QLineEdit()
        params_value.setText(value)
        layout.addWidget(params_value)
class WidgetParamDate(QWidget):
    def __init__(self,name,value,value_date,date_def_width=60,parent=None):
        QWidget.__init__(self,parent)
        layout = QHBoxLayout()
        self.setLayout(layout)
        name_params=QLabel()
        name_params.setText(name)
        layout.addWidget(name_params)
        params_value=QLineEdit()
        params_value.setText(value)
        layout.addWidget(params_value)
        name_params_date = QLabel()
        name_params_date.setText("Дата")
        layout.addWidget(name_params_date)
        params_value_date = QLineEdit()
        params_value_date.setText(value_date)
        params_value_date.adjustSize()
        params_value_date.setMaximumWidth(date_def_width)
        layout.addWidget(params_value_date)


class WidgetParamText(QWidget):
    def __init__(self,name,value,parent=None):
        QWidget.__init__(self,parent)
        layout = QVBoxLayout()
        self.setLayout(layout)
        name_params=QLabel()
        name_params.setText(name)
        layout.addWidget(name_params)
        params_value=QTextEdit()
        params_value.setMinimumHeight(20)
        params_value.setMaximumHeight(60)
        params_value.setText(value)
        params_value.adjustSize()

        layout.addWidget(params_value)
class DlgTest(QDialog):
    def __init__(self,parent=None):
        super().__init__(parent)
        self.window=self.load_ui("dlg_test.ui",parent)
        w_param_1=WidgetParamDate("test1","value_tes1","01.23")
        item_1 = QListWidgetItem()
        item_1.setSizeHint(w_param_1.sizeHint())
        self.window.listWidget.addItem(item_1)
        self.window.listWidget.setItemWidget(item_1, w_param_1)
        w_param_2 = WidgetParam("Главный инжинер проекта", "Петров П.П zzzz")
        item_2 = QListWidgetItem()
        item_2.setSizeHint(w_param_2.sizeHint())
        self.window.listWidget.addItem(item_2)
        self.window.listWidget.setItemWidget(item_2, w_param_2)
        w_param_2 = WidgetParamText("Название", "Пример Карты Шатмп")
        item_2 = QListWidgetItem()
        item_2.setSizeHint(w_param_2.sizeHint())
        self.window.listWidget_header.addItem(item_2)
        self.window.listWidget_header.setItemWidget(item_2, w_param_2)
        w_param_2 = WidgetParam("Дата 1", "12.24")
        item_2 = QListWidgetItem()
        item_2.setSizeHint(w_param_2.sizeHint())
        #self.window.listWidget_date.addItem(item_2)
        #self.window.listWidget_date.setItemWidget(item_2, w_param_2)
    def load_ui(self,name_resource,parent):
        loader = QUiLoader()
        path = os.path.join(os.path.dirname(__file__),name_resource)
        ui_file = QFile(path)
        ui_file.open(QFile.ReadOnly)
        ui  = loader.load(ui_file,parent)
        ui_file.close()
        return ui
    def show(self):
        self.window.show()
