from PySide2.QtCore import QMarginsF
from PySide2.QtGui import QPageSize, QPageLayout
from PySide2.QtPrintSupport import QPrinter
from axipy import view_manager

#from ru_axioma_gis_stamp_to_report.Test.NewTrasformStamp import cls_stamp
from ru_axioma_gis_stamp_to_report.ui.tools.db.dbTools import DbTools
from ru_axioma_gis_stamp_to_report.ui.tools.stamp_cls import loadStampDescription


def initPrinter(pageSize):
    printer = QPrinter()
    printer.setPageSize(QPageSize(pageSize))
    layout = QPageLayout(QPageSize(pageSize), QPageLayout.Landscape, QMarginsF())
    printer.setPageLayout(layout)
    printer.setOutputFormat(QPrinter.PdfFormat)
    printer.setOutputFileName(r"E:\Support\AxiomaTesting\Report\a3_stamp.pdf")
    return printer

path_db=r"E:\Support\AxiomaTesting\Report\Stamp\stamp_test.db"
db=DbTools(path_db)
reportview = view_manager.create_reportview()
printer=initPrinter(QPageSize.A3)
reportview.set_printer(printer)
id_stamp=[1,2,3]
list_stamp=[]
for id in id_stamp:
    cls_stamp=loadStampDescription(db,id)
    if cls_stamp is not None:
        list_stamp.append(cls_stamp)
db.close()