from PySide2.QtGui import QPageSize
from axipy import LinearUnits, provider_manager, data_manager, TypeSqlDialect, UnitValue, MapReportItem, view_manager, \
    Pnt

from ru_axioma_gis_stamp_to_report.ui.tools.db.dbTools import DbTools
from ru_axioma_gis_stamp_to_report.ui.tools.pages_report.helper_report import createReportView
from ru_axioma_gis_stamp_to_report.ui.tools.pages_report.virtual_pages import PageForStamp

#from ru_axioma_gis_stamp_to_report.ui.tools.pages_report.virtual_pages import PageForStamp

#from ru_axioma_gis_stamp_to_report.ui.tools.pages_report.virtual_pages import PageForStamp
map_view=view_manager.active
scale=UnitValue(2500,LinearUnits.cm)
size_page=QPageSize.A4
view_report=createReportView(size_page,0)
path_table=r"E:\Support\AxiomaTesting\Report\list_bounds_2500_1.tab"
path_table=r"E:\Support\AxiomaTesting\Report\list_bounds_big_2500_1.tab"
path_db=r"E:\Support\AxiomaTesting\Report\Stamp\stamp_test.db"
name_field_list_id='id_list'
db=DbTools(path_db)
base_page=PageForStamp(db)

id_page=[4,5]
id_page=[1,2,3]
#base_page.setPageSize(size_page,1)

base_page.setPageSize(size_page,0)
base_page.load(id_page)
db.close()
tab_list=provider_manager.openfile(path_table)
query_sql="select "+name_field_list_id+" from "+tab_list.name+' order by '+name_field_list_id
query_id=data_manager.query(query_sql,TypeSqlDialect.axioma)

cur_scale=scale.value*100
for i,ft in enumerate(query_id.items()):
    pt_center=ft.geometry.centroid()
    print("List "+str(i))
    if i>0:
        view_report.report.vertical_pages = i+1
    base_page.drawBigStamp(view_report,i)
    bound_map=base_page.mapBound(i,LinearUnits.cm)
    print("Start point:X="+str(bound_map.xmin)+" Y="+str(bound_map.ymin)+" width="+str(bound_map.width)+" height="+str(bound_map.height))
    mapItem = MapReportItem(bound_map, map_view.map)
    mapItem.center=Pnt(pt_center.x,pt_center.y)
    mapItem.scale=cur_scale
    view_report.report.items.add(mapItem)
#tab_list.close()
