import os

import axipy
from PySide2.QtGui import QIcon
from axipy import Plugin, Position

from ru_axioma_gis_stamp_to_report.ui.docWidget import AxiDocWidget, addDoc, existDocWidget, DelDocWidget
from ru_axioma_gis_stamp_to_report.ui.main_form_dlg import MainFormReportStamp
from ru_axioma_gis_stamp_to_report.ui.tools.helper_data_plugins.helper_config import DataPlugins


class ReportStam(Plugin):
    def __init__(self):
        super().__init__()
        self.__name = "Создание отчетов c оформлением"
        self.__form_tool = None
        self.__docWidget = None
        self._title = self.tr(self.__name)
        local_file_icon_1 = os.path.join(os.path.dirname(os.path.realpath(__file__)), 'ui/icons', 'icons8-report-32.png')
        self.__icon_tools = QIcon(local_file_icon_1)
        self.__action = self.create_action(title=self._title,
                                           icon=local_file_icon_1, on_click=self.__run,tooltip=self.__name)
        position = Position('Отчет', 'Операции')
        position.add(self.__action)
        self.__cls_data_plugins=DataPlugins(self.get_plugin_data_dir())

    def __run(self):
        if self.__form_tool is None:
            # self.__form_tool = DlgLoadOsm(self, axipy.mainwindow.qt_object())
            self.__form_tool = MainFormReportStamp(self.__cls_data_plugins,axipy.mainwindow.widget)
        if self.__docWidget is None:

            self.__docWidget = AxiDocWidget(self.__form_tool, self.__name, self.__name,
                                            self.__icon_tools, axipy.view_manager.global_parent)
            addDoc(axipy.app.mainwindow.qt_object(), self.__docWidget)
        else:
            isExist = existDocWidget(axipy.view_manager.global_parent, self.__docWidget)
            self.__docWidget.setVisible(True)
            self.__docWidget.setFocus()
            self.__docWidget.raise_()
    def unload(self) -> None:
        if self.__form_tool is not None:
            self.__form_tool=None
        if self.__docWidget is not None:

            DelDocWidget(axipy.app.mainwindow.qt_object(), self.__docWidget)
        self.__action.remove()