import os

import axipy
from PySide2.QtCore import Qt
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QWidget
from axipy import data_manager, view_manager

#from ru_axioma_gis_stamp_to_report.Test.CreateReport.Test1 import orientation
from ru_axioma_gis_stamp_to_report.ui.tools.Observers import tableInListForStamp, tabInMap, tableIsNeedForStamp
from ru_axioma_gis_stamp_to_report.ui.tools.cls_runner_create_report import PropertyRaportMap, CreateReportMap
from ru_axioma_gis_stamp_to_report.ui.tools.helper_tab import TableListInfo
from ru_axioma_gis_stamp_to_report.ui.tools.pages_report.helper_printer import createPdfPrinter
from ru_axioma_gis_stamp_to_report.ui.tools.pages_report.helper_report import createReportViewNew


class FormCreateReportFromList(QWidget):
    def __init__(self,parent_obj,parent=None):
        super().__init__(parent)
        self.__parent_obj=parent_obj
        ui_file = os.path.join(os.path.dirname(__file__), "form_create_report_from_list_1.ui")
        # Загружаем файл ui
        self.__ui = QUiLoader().load(ui_file, parent)
        self.__tab_manager = TableListInfo()
        self.__initBaseComboxList()

        self.__ui.cb_base_list.currentIndexChanged.connect(self.__changed_table_base)

        data_manager.removed.connect(self.__remove_tables)
        data_manager.added.connect(self.__add_tables)
        self.__ui.rb_stamp_4.toggled.connect(self.__change_status_stamp_3line)
        self.__changed_table_base(0)
        self.__ui.pb_run.clicked.connect(self.__run)
    def __initBaseComboxList(self):
        self.__ui.cb_base_list.clear()
        for tab in data_manager.tables:
            isListTab=tableInListForStamp(tab)
            if isListTab:
                if tabInMap(view_manager.active.map,tab) is not None:
                    self.__ui.cb_base_list.addItem(tab.name)
                    self.__tab_manager.addTable(tab)
        self.__ui.cb_base_list.setCurrentIndex(0)
        if self.__ui.cb_base_list.count()>1 and (not self.__ui.rb_stamp_4. isChecked()):

            self.__ui.gbx_standart.setEnabled(True)
        else:
            self.__ui.gbx_standart.setEnabled(False)
    def active(self):
        self.__initBaseComboxList()
    def __remove_tables(self,name_tab):
        if not tableIsNeedForStamp(name_tab):
           return
        index=self.__ui.cb_base_list.findText(name_tab,Qt.MatchContains)
        if index <0:
            return
        self.__ui.cb_base_list.removeItem(index)
        self.__tab_manager.removedTable(name_tab)
        if self.__ui.cb_base_list.count()<2:
            self.__ui.gbx_standart.setEnabled(False)
    def __add_tables(self,name_tab):
        if not tableIsNeedForStamp(name_tab):
            return
        self.__ui.cb_base_list.addItem(name_tab)
        self.__tab_manager.addTable(name_tab)
        if self.__ui.cb_base_list.count()>1 and (not self.__ui.rb_stamp_4.isChecked()):
            self.__ui.gbx_standart.setEnabled(True)
        self.__changed_table_base(0)
    def __change_status_stamp_3line(self):
        self.__ui.gbx_standart.setEnabled(not self.__ui.rb_stamp_4.isChecked())
    def __changed_table_base(self,index):
        select_table=self.__ui.cb_base_list.currentText()
        if self.__ui.cb_base_list.count()>1:
            self.__initListTableSecond(select_table)
        page_info=self.__tab_manager.getPageinfo(select_table)
        if page_info is not None:
            self.__ui.labelpage_format.setText(page_info.toString)

    def __initListTableSecond(self,name_select_first):
        self.__ui.cmb_second_list.clear()
        for i in range(self.__ui.cb_base_list.count()):
            name=self.__ui.cb_base_list.itemText(i)
            if name==name_select_first:
                continue
            self.__ui.cmb_second_list.addItem(name)
        self.__ui.cmb_second_list.setCurrentIndex(0)
        return
    def __run(self):
        cls_params=self.__parent_obj.getParametrsStamp()
        name_table_list_base=self.__ui.cb_base_list.currentText()
        active_map = view_manager.active
        tab_base=data_manager.find(name_table_list_base)
        not_visible_tab=self.__ui.ch_base_is_visble.isChecked()
        page_info=self.__tab_manager.getPageinfo(name_table_list_base)
        type_stamp_base=0
        if self.__ui.rb_stamp_4.isChecked():
            type_stamp_base=1
        base_params = PropertyRaportMap(active_map, tab_base, type_stamp_base, not_visible_tab)
        second_params=None
        if self.__ui.gbx_standart.isChecked():
            name_tab_second=self.__ui.cmb_second_list.currentText()
            tab_second=data_manager.find(name_tab_second)
            not_visible_tab_second = self.__ui.ch_base_is_visble_second.isChecked()
            second_params = PropertyRaportMap(active_map, tab_second, 1, not_visible_tab_second)
        printer = createPdfPrinter(page_info.page_size, page_info.orientation)
        report_view = createReportViewNew(page_info, printer)
        self.__cls_run=CreateReportMap(cls_params,base_params,second_params,page_info,report_view,printer)
        self.__cls_run.change_progress.connect(self.__update_progess)
        ''''
        def run_process(t: axipy.Task):
            self.__cls_run.run()

        self.__run_task = axipy.Task(run_process)
        self.__run_task.finished.connect(self.__finish_task)
        self.__run_task.start()
        '''
        self.__cls_run.run()
        self.__finish_task()
    def __finish_task(self):
        self.__cls_run.change_progress.disconnect(self.__update_progess)
        #self.__cls_run.change_progress_bar_format.disconnect(self.__update_progess_format)
        self.__ui.pb_run.setEnabled(True)
        self.__ui.pb_cancel.setEnabled(False)


        self.__cls_run=None
    def __update_progess(self, value):
        # print(value)
        self.__ui.progressBar.setValue(value)




