import os

from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QWidget
from axipy import view_manager, MapView

from ru_axioma_gis_stamp_to_report.ui.tools.helper_tab import TableListInfo


class FormCreateReport(QWidget):
    def __init__(self,parent_obj,parent):
        super().__init__(parent)
        ui_file = os.path.join(os.path.dirname(__file__), "form_create_report.ui")
        # Загружаем файл ui
        self.__ui = QUiLoader().load(ui_file, parent)

        self.__init_scale()
        view_manager.active_changed.connect(self.__change_view)
        self.__change_view()
        self.__ui.spinBox_count_list.valueChanged.connect(self.__change_count_list_spin)
        self.__ui.pb_run.clicked.connect(self.__run)
    def __init_scale(self):
        scales=['100','250','500','1000','2000','5000','10000','25000']
        self.__ui.cmb_scale.addItems(scales)
    def show(self):
        self.__ui.show()
    def __change_view(self):
        self.__ui.groupBox_template.setChecked(False)
        if not isinstance(view_manager.active,MapView):
            self.__ui.groupBox_list_report.setEnabled(False)
            self.__ui.groupBox_template.setChecked(True)
            return
        if view_manager.active.coordsystem.lat_lon:
            self.__ui.groupBox_list_report.setEnabled(False)
            self.__ui.groupBox_template.setChecked(True)
            return
        #self.__toolbox.setItemEnabled(1, True)
        return
    def __change_count_list_spin(self,value):
        if value==1:
            self.__ui.groupBox__next_list.setEnabled(False)
        else:
            self.__ui.groupBox__next_list.setEnabled(True)
    def __run(self):
        pass
