import os

import axipy
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QWidget
from axipy import view_manager, MapView

from ru_axioma_gis_stamp_to_report.ui.tools.pages_report.createReport import BuilderReport, CounterPages
from ru_axioma_gis_stamp_to_report.ui.tools.pages_report.helper_printer import createPdfPrinter
from ru_axioma_gis_stamp_to_report.ui.tools.pages_report.helper_report import createReportViewNew


class FormCreateTemplateReport(QWidget):
    def __init__(self,parent_obj,parent):
        super().__init__(parent)
        ui_file = os.path.join(os.path.dirname(__file__), "form_create_template1.ui")
        # Загружаем файл ui
        self.__ui = QUiLoader().load(ui_file, parent)
        self.__init_scale()
        #view_manager.active_changed.connect(self.__change_view)
        #self.__change_view()
        self.__parent_obj=parent_obj
        self.__ui.spinBox_count_list.valueChanged.connect(self.__change_count_list_spin)
        self.__ui.pb_run.clicked.connect(self.__run)
        self.__initInforPageSize()
    def __init_scale(self):
        scales=['100','250','500','1000','2000','5000','10000','25000']
        self.__ui.cmb_scale.addItems(scales)
    def __initInforPageSize(self):
        page_info=self.__parent_obj.getCurentSizeList()
        if page_info is not None:
            self.__ui.label_format_list.setText(page_info.toString)
    def update_page_info(self):
        self.__initInforPageSize()
    def show(self):
        self.__ui.show()
    def __change_view(self):
        self.__ui.groupBox_template.setChecked(False)
        if not isinstance(view_manager.active,MapView):
            self.__ui.groupBox_list_report.setEnabled(False)
            self.__ui.groupBox_template.setChecked(True)
            return
        if view_manager.active.coordsystem.lat_lon:
            self.__ui.groupBox_list_report.setEnabled(False)
            self.__ui.groupBox_template.setChecked(True)
            return
        #self.__toolbox.setItemEnabled(1, True)
        return
    def __change_count_list_spin(self,value):
        if value==1:
            self.__ui.groupBox__next_list.setEnabled(False)
        else:
            self.__ui.groupBox__next_list.setEnabled(True)
    def __run(self):
        page_info=self.__parent_obj.getCurentSizeList()
        printer_curent=createPdfPrinter(page_info.page_size,page_info.orientation)
        view_report=createReportViewNew(page_info,printer_curent)
        self.__cls_run=BuilderReport(self.__parent_obj.getParametrsStamp(),self.__parent_obj.getCurentSizeList(),printer_curent,view_report)
        count_page=self.__ui.spinBox_count_list.value()

        head_stamp= self.__ui.rb_stamp_8.isChecked()
        ragular_stamp=0
        if self.__ui.rb_stamp_4.isChecked():
            ragular_stamp=1
        cls_counter = CounterPages(count_page, head_stamp, ragular_stamp)
        self.__cls_run.setInfoPagesCount(cls_counter)
        self.__cls_run.change_progressBar.connect(self.__update_progess)
        self.__ui.pb_run.setEnabled(False)
        self.__ui.pb_cancel.setEnabled(True)
        def run_process(t: axipy.Task):
            self.__cls_run.run()

        self.__run_task = axipy.Task(run_process)
        self.__run_task.finished.connect(self.__finish_task)
        self.__run_task.start()
    def __finish_task(self):
        self.__cls_run.change_progressBar.disconnect(self.__update_progess)

        self.__ui.pb_run.setEnabled(True)
        self.__ui.pb_cancel.setEnabled(False)


        self.__cls_run=None

    def __update_progess(self,value):
        self.__ui.progressBar.setValue(value)
