import os

from PySide2.QtCore import QFile, Signal
from PySide2.QtGui import QPageSize, QPageLayout
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QWidget

from ru_axioma_gis_stamp_to_report.ui.tools.pages_report.helper_printer import PageInfo


class FormSizelistOut(QWidget):
    __size_paper=[QPageSize.A4,QPageSize.A3,QPageSize.A2,QPageSize.A1,QPageSize.A0]
    change_page_info=Signal()
    def __init__(self,data_lugins,parent=None):
        super().__init__(parent)
        self.__cls_data_plugins=data_lugins
        #QWidget.__init__(self, parent)
        self.__ui =self.load_ui("form_size_list_1.ui",parent)
        self.__initGui()
        self.__ui.pb_save.clicked.connect(self.__save_config)
    def load_ui(self,name_resource,parent):
        loader = QUiLoader()
        path = os.path.join(os.path.dirname(__file__),name_resource)
        ui_file = QFile(path)
        ui_file.open(QFile.ReadOnly)
        ui  = loader.load(ui_file,parent)
        ui_file.close()
        return ui
    def __initGui(self):
        data_size=self.__cls_data_plugins.loadConfigListSize()
        if data_size['orientation']==0:
            self.__ui.rb_Portret.setChecked(True)
            self.__ui.rb_landscape.setChecked(False)
        else:
            self.__ui.rb_Portret.setChecked(False)
            self.__ui.rb_landscape.setChecked(True)

        for i,size_list in enumerate(self.__size_paper):
            name_size=size_list.name.decode('utf-8')
            self.__ui.cmb_list_name.addItem(name_size)
            if name_size==data_size['name_list']:
                self.__ui.cmb_list_name.setCurrentIndex(i)

    def __save_config(self):
        name_list=self.__ui.cmb_list_name.currentText()
        orientation=0
        if self.__ui.rb_landscape.isChecked():
            orientation=1
        self.__cls_data_plugins.saveConfigListSize({"name_list":name_list,"orientation":orientation})
        self.change_page_info.emit()
    @property
    def curentSizeList(self):
        curent_page_size=QPageSize.A4
        name_list = self.__ui.cmb_list_name.currentText()
        for name_size in self.__size_paper:
            if name_size.name.decode('utf-8')==name_list:
                curent_page_size=name_size
                break
        orientation = 0
        if self.__ui.rb_landscape.isChecked():
            orientation = 1
        orientation_page=QPageLayout.Portrait
        if orientation==1:
            orientation_page=QPageLayout.Landscape
        return PageInfo(curent_page_size,orientation_page)
    @property
    def widget(self):
        self.__ui