import os

from PySide2.QtCore import QFile
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QWidget, QToolBox, QGridLayout
from axipy import view_manager, MapView

from ru_axioma_gis_stamp_to_report.ui.cls_form_greateList import CreateListsTab
from ru_axioma_gis_stamp_to_report.ui.cls_from_create_report import FormCreateReportFromList
from ru_axioma_gis_stamp_to_report.ui.formCreateReport import FormCreateReport
from ru_axioma_gis_stamp_to_report.ui.formCreateTemplateReport import FormCreateTemplateReport
from ru_axioma_gis_stamp_to_report.ui.form_size_list_report import FormSizelistOut
from ru_axioma_gis_stamp_to_report.ui.form_widget_params_stamp import WidgetParamsStamp
from ru_axioma_gis_stamp_to_report.ui.tools.Observers import factoryExistTableListForReport
from ru_axioma_gis_stamp_to_report.ui.tools.pages_report.virtual_pages import DbStampPage


class MainFormReportStamp(QWidget):
    def __init__(self,cls_plugin_data,parent=None):
        QWidget.__init__(self,parent)
        self.__stamp_db=DbStampPage()
        self.__cls_data_plugin=cls_plugin_data
        layout = QGridLayout()
        self.setLayout(layout)
        self.__toolbox = QToolBox()
        self.__toolbox.currentChanged.connect(self.__change_active_tool)
        layout.addWidget(self.__toolbox, 0, 0)
        self.__cls_size_list = FormSizelistOut(self.__cls_data_plugin,self.__toolbox)
        self.__toolbox.setItemText (0, "Параметры листа отчета")
        #toolbox.addItem(self.__cls_size_list, "Параметры листа отчета")
        self.__cls_createList = CreateListsTab(self,self.__toolbox)
        self.__toolbox.setItemText(1, "Создание таблицы листов ( нарезки)")
        self.__cls_params_stamp=WidgetParamsStamp(self,self.__toolbox)
        self.__toolbox.setItemText(2, "Параметры штампа")
        self.__cls_create_template_report=FormCreateTemplateReport(self,self.__toolbox)
        self.__toolbox.setItemText(3, "Создание шаблона отчета")
        self.__cls_create_report=FormCreateReportFromList(self,self.__toolbox)
        self.__toolbox.setItemText(4, "Создание отчета")
        #self.__cls_createList = CreateListsTab(self.__ui.toolBox)
        #self.__ui.toolBox.addItem(self.__cls_createList.widget,"Test Create List")
        #self.__ui.toolBox.addItem(self.__cls_createList.widget, "Test Create List_2")
        #self.__ui.toolBox.removeItem(0)
        view_manager.active_changed.connect(self.__change_view)
        self.__change_view()
        observer = factoryExistTableListForReport()
        self.__toolbox.setItemEnabled(4, observer.value)

        observer.changed.connect(self.__status_create_report)
        self.__status_create_report(observer.value)
        self.__toolbox.currentChanged.connect(self.__change_active_item)
        self.__cls_size_list.change_page_info.connect(self.__change_page_info)
    def load_ui(self,name_resource,parent):
        loader = QUiLoader()
        path = os.path.join(os.path.dirname(__file__),name_resource)
        ui_file = QFile(path)
        ui_file.open(QFile.ReadOnly)
        ui  = loader.load(ui_file,parent)
        ui_file.close()
        return ui
    @property
    def cls_tsmp_db(self):
        return self.__stamp_db
    def getCurentSizeList(self):
        return self.__cls_size_list.curentSizeList
    def __change_active_tool(self,index):
        '''
        if index==1 or index==3:
            self.__cls_createList.update_page_info()
        '''
        pass
    def __change_page_info(self):
        self.__cls_createList.update_page_info()
        self.__cls_create_template_report.update_page_info()

    @property
    def plugin_data_folder(self):
        return self.__cls_data_plugin.get_plugin_data_dir
    def getBoundMapStampBig(self):
        #parm_page_size,orientation=self.__cls_size_list.curentSizeList
        page_info=self.__cls_size_list.curentSizeList
        bound =self.__stamp_db.getBoundMapBigPage(page_info.page_size,page_info.orientation)
        return bound
    def getBoundMapStampStandart(self):
        #parm_page_size,orientation=self.__cls_size_list.curentSizeList
        page_info=self.__cls_size_list.curentSizeList
        bound =self.__stamp_db.getBoundMapStandartPage(page_info.page_size,page_info.orientation)
        return bound
    def getBoundFull(self):
        page_info=self.__cls_size_list.curentSizeList
        #parm_page_size, orientation = self.__cls_size_list.curentSizeList
        bound = self.__stamp_db.getWorkBoundPage(page_info.page_size,page_info.orientation)
        return bound
    def __change_view(self):
        if not isinstance(view_manager.active,MapView):
            self.__toolbox.setItemEnabled(1,False)
            self.__toolbox.setItemEnabled(4, False)
            return
        if view_manager.active.coordsystem.lat_lon:
            self.__toolbox.setItemEnabled(1, False)
            self.__toolbox.setItemEnabled(4, False)
            return
        self.__toolbox.setItemEnabled(1, True)
        self.__toolbox.setItemEnabled(4, True)
        return
    def getParametrsStamp(self):
        return self.__cls_params_stamp.getParametrsStamp()
    def __status_create_report(self,value):
        self.__toolbox.setItemEnabled(4, value)

    def __change_active_item(self,index_item):
        if index_item==4:
            self.__cls_create_report.active()

    '''
    @property
    def widget(self):
        return self.__ui
    '''
