import os

from PySide2.QtCore import QFile
from PySide2.QtUiTools import QUiLoader
from PySide2.QtWidgets import QWidget, QToolBox

from ru_axioma_gis_stamp_to_report.ui.cls_form_greateList import CreateListsTab
from ru_axioma_gis_stamp_to_report.ui.form_size_list_report import FormSizelistOut


class MainFormReportStamp(QWidget):
    def __init__(self,parent=None):
        super().__init__(parent)
        self.__ui=self.load_ui("main_form.ui",parent)

        count=self.__ui.toolBox.count()

        self.__cls_size_list = FormSizelistOut(self.__ui.toolBox)
        self.__cls_createList = CreateListsTab(self.__ui.toolBox)
        #self.__ui.toolBox.addItem(self.__cls_createList.widget,"Test Create List")
        #self.__ui.toolBox.addItem(self.__cls_createList.widget, "Test Create List_2")
        self.__ui.toolBox.removeItem(0)
    def load_ui(self,name_resource,parent):
        loader = QUiLoader()
        path = os.path.join(os.path.dirname(__file__),name_resource)
        ui_file = QFile(path)
        ui_file.open(QFile.ReadOnly)
        ui  = loader.load(ui_file,parent)
        ui_file.close()
        return ui
    @property
    def widget(self):
        return self.__ui
