import axipy
from axipy import data_manager, selection_manager, Observer, Polygon, view_manager, observer_manager, MultiPolygon, Map, \
    Rectangle, ListLayers, MapView


def existListTableInAxioma():
    count_tab = 0
    for tab_item in data_manager.tables:
        if tableInListForStamp(tab_item):
            count_tab = count_tab + 1

            if count_tab > 0:

                return True


    return False
def selectionIsPolygons():
    retValue=False
    if axipy.gui.selection_manager.count == 0:

        return False
    tab_sel = data_manager.selection
    count_poly=0
    for ft in tab_sel.items():
        if isinstance(ft.geometry,Polygon):
            count_poly=count_poly+1
    if count_poly==0:
        return False
    if count_poly==1:
        return True
    return False
    '''    
    sql = 'Select Count(*) as count  from ' + tab_sel.name + ' Where Str$(obj)="Region" or Str$(obj)="Collection" group by  Str$(obj)'
    tab_is_regions = data_manager.query_hidden(sql)
    if tab_is_regions.count() == 0:
        retValue=False
    else:
        if tab_is_regions.count()==1:
            retValue=True
    tab_is_regions.close()
    '''
    #return retValue
def factoryObserverSelectPolygons(name_observer):
    observer=None
    try:
        observer=axipy.observer_manager.get(name_observer)
    except:
        pass
    if observer is None:
        observer=axipy.Observer(name_observer,False)
        def changeSelection():
            if axipy.gui.selection_manager.count==0:
                observer.setValue(False)
                return
            #tab_sel=axipy.gui.selection_manager.get_as_table()
            tab_sel=axipy.SelectionTable
            sql='Select Count(*) as count  from ' + tab_sel.name + ' Where Str$(obj)="Region" or Str$(obj)="Collection" group by  Str$(obj)'
            tab_is_regions=data_manager.query_hidden(sql)
            count_obj=tab_is_regions.count()
            tab_is_regions.close()
            if count_obj==0:
                observer.setValue(False)
            else:
                if count_obj == 1:
                    observer.setValue(True)
                else:
                    observer.setValue(False)

        setattr(observer, "changeSelection", changeSelection)

        axipy.gui.selection_manager.changed.connect(observer.changeSelection)

        return observer
    return observer
def factoryObserverSelectPolygonsNew(name_observer):
    #observer=axipy.ObserverManager.get(name_observer)
    observer = axipy.observer_manager.get(name_observer)
    if observer is not None:
        return observer

    observer=Observer(name_observer,False)

    def changeSelection():
        count_selection=selection_manager.count
        if count_selection==0:
            observer.value=False
            return
        if count_selection>1:
            observer.value = False
            return
        observer.value=selectionIsPolygons()
        return

    setattr(observer, "changeSelection", changeSelection)

    axipy.gui.selection_manager.changed.connect(observer.changeSelection)
    observer.value=selectionIsPolygons()
    return observer
def tabInLayers(layers:ListLayers,tab):
    for layer in layers:
        if isinstance(layer,ListLayers):
            return tabInLayers(layer,tab)
        tab_layer=layer.data_object
        if tab_layer.name==tab.name:
            return layer
    return False
def tabInMap(map:Map,table):
    layrs=map.layers
    return tabInLayers(layrs,table)
def tableIsNeedForStamp(name_tab):
    tab = data_manager.find(name_tab)
    if tab is None:
        return False
    if not tableInListForStamp(tab):
        return False
    if not isinstance(view_manager.active,MapView):
        return False
    if tabInMap(view_manager.active.map, tab) is None:
        return False
    return True
def factoryObserverSelectPolygon(name="SelectOnePolygonInMap"):
    observer=observer_manager.get(name)
    if observer is not None:
        return observer
    observer= axipy.Observer(name,False)
    def change_selection():
        if not(selection_manager.count == 1) :
            observer.value=False
            return
        tab_sel = data_manager.selection
        base_table = tab_sel.base_table
        geo_selection=list(tab_sel.items())[0].geometry
        if not(isinstance(geo_selection,Polygon) or isinstance(geo_selection,MultiPolygon) or isinstance(geo_selection,Rectangle)):
            observer.value = False
            return
        layer = tabInMap(view_manager.active.map, base_table)
        if layer is not None:
            observer.value = True
            return
        observer.value = False

    selection_manager.changed.connect(change_selection)
    change_selection()
    return observer
def tableInListForStamp(table):
    count_eq_fields=0
    for att in table.schema:
        if att.name=='id_list' or att.name=='scale':
            count_eq_fields=count_eq_fields+1
    if count_eq_fields==2:
        return True
    return False
def factoryExistTableListForReport(name="ExistTableForReport"):
    observer = observer_manager.get(name)
    if observer is not None:
        return observer
    observer = axipy.Observer(name, False)
    def add_table(name_table):
        if observer.value:
            return
        tab=data_manager.find(name_table)
        if tab is None:
            return
        if not isinstance(tab,axipy.Table):
            return
        observer.value=tableInListForStamp(tab)
    def remove_table(name_table):

        if not observer.value:
            return
        if data_manager.count==1:
            observer.value=False
            return
        if len(data_manager.tables)==1:
            observer.value = False
            return
        tab = data_manager.find(name_table)
        if tab is None:
            return
        if not isinstance(tab, axipy.Table):
            return
        if not tableInListForStamp(tab):
            return
        count_tab=0
        for tab_item in data_manager.tables:
            if tableInListForStamp(tab_item):
                count_tab=count_tab+1
                if count_tab>2:
                    return
        if count_tab<2:
            observer.value=False
        return

    data_manager.added.connect(add_table)
    data_manager.removed.connect(remove_table)
    observer.value=existListTableInAxioma()
    return observer








