from PySide2.QtCore import Signal, QObject

from ru_axioma_gis_stamp_to_report.ui.tools.Observers import tabInMap
from ru_axioma_gis_stamp_to_report.ui.tools.pages_report.helper_printer import createPdfPrinter
from ru_axioma_gis_stamp_to_report.ui.tools.pages_report.virtual_pages import DbStampPage, MapPrinter


class PropertyRaportMap:
    def __init__(self,map_view,table_list,size_stamp,not_view_list):
        self.map_view=map_view
        self.table_list=table_list
        self.size_stam=size_stamp
        self.not_view_list=not_view_list

class CalcIntProcent:
    def __init__(self,count):
        self.__last_proc=-1
        self.__count=count
    def getValue(self,curent):
        cur_val=int((curent/self.__count)*100+0.5)
        if cur_val==self.__last_proc:
            return None
        self.__last_proc=cur_val
        return cur_val
class CreateReportMap(QObject):
    change_progress = Signal(int)
    def __init__(self,param_stamp,property_base_map,property_second_map,page_info,viewreport,printer=None):
        super().__init__()
        self.__pages=DbStampPage(param_stamp)

        self.__property_base_map=property_base_map
        self.__property_second_map=property_second_map
        self.__page_info=page_info
        self.__viewreport=viewreport
        self.__map_printer_second=None
        self.__map_printer_base=MapPrinter(viewreport,property_base_map.map_view,self.__pages,self.__page_info)
        if self.__property_second_map is not None:
            self.__map_printer_second = MapPrinter(viewreport, self.__property_second_map.map_view, self.__pages, self.__page_info)
        if printer is None:
            self.__printer = createPdfPrinter(self.__page_info.page_size, self.__page_info.orientation)
    def run(self):
        all_count_page=self.__property_base_map.table_list.count()
        base_count=all_count_page
        second_count=0
        if self.__property_second_map is not None:
            second_count=self.__property_second_map.table_list.count()
            all_count_page=all_count_page+second_count
        layer_list_tab_base=tabInMap(self.__property_base_map.map_view.map,self.__property_base_map.table_list)
        if self.__property_base_map.not_view_list:
            layer_list_tab_base.visible=False
        index_page=0
        self.change_progress.emit(0)
        cls_proggress=CalcIntProcent(all_count_page)
        for i,ft in enumerate(self.__property_base_map.table_list.items()):
            index_page=index_page+1
            pgress_proc=cls_proggress.getValue(index_page)
            if pgress_proc is not None:
                self.change_progress.emit(pgress_proc)
            if self.__property_base_map.size_stam==0:
                self.__pages.pageBigStamp.addParamList("count_list", str(all_count_page))
                self.__pages.pageBigStamp.addParamList("curent_list", str(index_page))
                self.__pages.printBigStamp(self.__viewreport,index_page-1)
            else:
                self.__pages.pageStandartStamp.addParamList("standart_curent_list", str(index_page))
                self.__viewreport.report.vertical_pages = index_page
                self.__pages.printStandartStamp(self.__viewreport, index_page - 1)
            self.__map_printer_base.printToReport(ft.geometry,ft['scale'],index_page-1)

        if self.__map_printer_base is not None:
            if self.__property_second_map is not None:
                for i,ft in enumerate(self.__property_second_map.table_list.items()):
                    index_page = index_page + 1
                    pgress_proc = cls_proggress.getValue(index_page)
                    if pgress_proc is not None:
                        self.change_progress.emit(pgress_proc)
                    self.__pages.pageStandartStamp.addParamList("standart_curent_list", str(index_page))
                    self.__viewreport.report.vertical_pages = index_page
                    self.__pages.printStandartStamp(self.__viewreport, index_page-1)
                    self.__map_printer_second.printToReport(ft.geometry,ft['scale'],index_page-1)
        self.change_progress.emit(100)





