import axipy
from axipy import observer_manager, selection_manager, data_manager, Polygon, MultiPolygon, Rectangle, ListLayers, Map, \
    view_manager


def tabInLayers(layers:ListLayers,tab):
    for layer in layers:
        if isinstance(layer,ListLayers):
            return tabInLayers(layer,tab)
        tab_layer=layer.data_object
        if tab_layer.name==tab.name:
            return layer
    return None
def tabInMap(map:Map,table):
    layrs=map.layers
    return tabInLayers(layrs,table)

def factoryObserverSelectPolygon(name="SelectOnePolygonInMap"):
    observer=observer_manager.get(name)
    if observer is not None:
        return observer
    observer= axipy.Observer(name,False)
    def change_selection():
        if not(selection_manager.count == 1) :
            observer.value=False
            return
        tab_sel = data_manager.selection
        base_table = tab_sel.base_table
        geo_selection=list(tab_sel.items())[0].geometry
        if not(isinstance(geo_selection,Polygon) or isinstance(geo_selection,MultiPolygon) or isinstance(geo_selection,Rectangle)):
            observer.value = False
            return
        layer = tabInMap(view_manager.active.map, base_table)
        if layer is not None:
            observer.value = True
            return
        observer.value = False

    selection_manager.changed.connect(change_selection)
    change_selection()
    return observer



