from PySide2.QtCore import QObject, Signal

from ru_axioma_gis_stamp_to_report.ui.tools.pages_report.helper_printer import createPdfPrinter, PageInfo
from ru_axioma_gis_stamp_to_report.ui.tools.pages_report.helper_report import createReportViewNew
from ru_axioma_gis_stamp_to_report.ui.tools.pages_report.virtual_pages import DbStampPage

class CounterPages:
    def __init__(self,count_page,head_stamp,regular_pages):
        '''Общее число страниц'''
        self.count_pages=count_page
        ''' тип первого листа'''
        self.head_stamp=head_stamp
        ''' тип регулярных страниц'''
        self.regular_pages=regular_pages
class CalcIntProcent:
    def __init__(self,count):
        self.__last_proc=-1
        self.__count=count
    def getValue(self,curent):
        cur_val=int((curent/self.__count)*100+0.5)
        if cur_val==self.__last_proc:
            return None
        self.__last_proc=cur_val
        return cur_val
class BuilderReport(QObject):
    change_progressBar=Signal(int)
    def __init__(self,params_report,page_info:PageInfo,printer=None,view_report=None):
        super().__init__()
        self.__params_report=params_report
        self.__page_info=page_info
        self.__printer=printer
        self.__pages=None
        self.__pages_counter=None

        self.__initPages()
        self.__initPrinter()
        self.__viewreport=view_report
    def __initPages(self):
        self.__pages=DbStampPage(self.__params_report)
    def __initPrinter(self):
        if self.__printer is not None:
            return
        self.__printer=createPdfPrinter(self.__page_info.page_size,self.__page_info.orientation)
    def setInfoPagesCount(self,pages_count:CounterPages):
        self.__pages_counter=pages_count
    def testRun(self):
        self.__viewreport=createReportViewNew(self.__page_info,self.__printer)
        self.__pages.printBigStamp(self.__viewreport)
        self.__viewreport.report.vertical_pages = 2
        self.__pages.printStandartStamp(self.__viewreport,1)
    def run(self):
        print("Start run")
        if self.__viewreport is None:
            self.__viewreport=createReportViewNew(self.__page_info,self.__printer)
        index_page=0
        cls_proc=CalcIntProcent(self.__pages_counter.count_pages)
        self.change_progressBar.emit(0)
        for index_page in range(self.__pages_counter.count_pages):
            value_procent=cls_proc.getValue(index_page+1)
            if value_procent is not None:
                self.change_progressBar.emit(value_procent)
            if index_page==0:
                if self.__pages_counter.count_pages:
                    ''' устанавливаем дополнительные параметры '''
                    self.__pages.pageBigStamp.addParamList("count_list",str(self.__pages_counter.count_pages))
                    self.__pages.pageBigStamp.addParamList("curent_list", "1")
                    self.__pages.printBigStamp(self.__viewreport)
                    continue
            self.__pages.pageStandartStamp.addParamList("standart_curent_list", str(index_page+1))
            self.__viewreport.report.vertical_pages=index_page+1
            self.__pages.printStandartStamp(self.__viewreport, index_page)
        self.change_progressBar.emit(100)




        