from PySide2.QtCore import QMarginsF
from PySide2.QtGui import QPageLayout, QPageSize
from PySide2.QtPrintSupport import QPrinter

class PageInfo:
    def __init__(self,page_size,orientation):
        self.page_size=page_size
        self.orientation=orientation
    @property
    def toString(self):
        name_page=QPageSize.name(self.page_size)
        out_str=name_page
        str_orientation="Портрет"
        if self.orientation==QPageLayout.Landscape:
            str_orientation="Альбом"
        return out_str+" "+str_orientation

def createPdfPrinter(size=QPageSize.A4,orientation=QPageLayout.Portrait):
    printer=QPrinter()
    printer.setOutputFormat(QPrinter.PdfFormat)

    printer.setPageSize(QPageSize(size))
    layout = QPageLayout(QPageSize(size), orientation, QMarginsF())
    printer.setPageLayout(layout)
    return printer